# Header Files

* Header files are a way of sharing code between several source files
* These filenames traditionally end in a (.h) *with out parentheses*
* Header files hold the declaration (aka prototype) of functions
* These functions are defined in supporting source files (.c)

---

* The C standard library header files have been logically organized (ie. stdio.h, stdlib.h, math.h, etc.)
* Programmers can write their own header files and even create their own libraries
* Libraries can be shared among programmmers

* <> loads system headers

```c
#include <stdio.h>
```

* "" loads headers from the local directory first

```c
#include "My_Local_Header.h"
```

### Examples

```c
///MyHeader.h///
#ifndef MY_HEADER_
#define MY_HEADER_

/*
* If a is larger than b, return 1
* If a is less than or equal to b, return 0
*/

extern int is_larger(int a, int b);
#endif //MY_HEADER_


// ===========================

///MyHeader.c///
#define MY_HEADER_YES 1
#define MY_HEADER_NO 0

extern int is_larger(int a, int b)
{
    if(a > b)
    {
        return MY_HEADER_YES;
    }
    else
    {
        return MY_HEADER_NO;
    }
}


// =======================================


///myCode.c///
#define _CRT_SECURE_NO_WARNINGS 1       //required to utilize scanf()
#include <stdio.h>                      //defines printf() and scanf()
#include "MyHeader.h"                   //your header

int main(void)
{
    int firstNum, secondNum;        // input variables
    _flushall();                    // flush the streams (This doesn't always work, but the function I provided last lab will)
    scanf("is %d larger than %d?", &firstNum, &secondNum);

    if (is_larger(firstNum, secondNum))         //if is_larger() returns 1...
    {
        printf("%d was larger\n", firstNum);    //...then firstNum was larger...
    }
    else    //...otherwise it returned 0 so...
    {
        printf("%d was larger\n", secondNum);   //...secondNum was larger
    }

    return 0;
}
```

---
### Some Header File Guidelines:

    1. Restrict yourself to logically related ideas
    2. Only #inlcude other header files you **NEED**
    3. Avoid established header file names
    4. Do not nest header files
    5. Inlcude per-function comment blocks
    6. Use header file guards
    7. Make names unique
    8. Do not include executable code
    9. #include headers may need to go in the header's source file (.c)

**NOTE:** Header file creation example in visual studio **ONLY**

    1. Start a new project (Ctrl+Shift+N)
    2. In “Solution Explorer”, right click “Header Files”, click“Add”, and select “New Item” (Ctrl+Shift+A)
    3. Select “Header File (.h)”, name it “StudentHeader.h”, andclick “Add”
    4. In “Solution Explorer”, right click “Source Files”, click“Add”, and select “New Item” (Ctrl+Shift+A)
    5. Select “C++ File (.cpp)”, name it “StudentHeader.c”,manually changing the file extension to (.c), and click “Add”
    6. Create another source file #include “StudentHeader.h”

---
